//
//  main.m
//  Foundation Training
//
//  Created by Holger Hinzberg on 21.03.11.
//  Copyright 2011 Cocoa-Coding. All rights reserved.
//

#import <Foundation/Foundation.h>

int main (int argc, const char * argv[])
{

    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
    
    // Eine einfache for-Schleife
    
    for (int a = 0; a < 10; a++)
    {
        double result = 1.25 * a; 
        NSLog(@"Ergebnis %f als double!",result);
        // Diese Anweisung ist falsch
        NSLog(@"Ergebnis %i als int?",result);
        // double wird zu int umgewandelt
        // So funktioniert es!
        NSLog(@"Ergebnis %i als int!",(int) result);
    }
    
    
    // 3.3	Zeichenketten mit NSString
    /*
    // Ein Textobjekt
    NSString * cycle = @"Durchlauf";
    
    for (int a = 0; a < 10; a++)
    {
        // Ein neues Textobjekt
        NSString *myValue =
        [NSString stringWithFormat:@"%i",a];
        
        // Das Textobjekt anhängen
        cycle = [cycle stringByAppendingString:myValue];
        NSLog(@"%@",cycle);

    }
    */
    
    // 3.4	Vergleichen von Zeichenketten
    /*
    NSString *text1 = @"HALLO Welt";
    NSString *text2 = @"Hallo WELT";
    
    if ( [text1 caseInsensitiveCompare:text2] == NSOrderedSame )
    {
        NSLog(@"Texte sind gleich.");
    }
    else
    {
        NSLog(@"Texte sind unterschiedlich.");
    }
    */
    
    // 3.5	Zeichenketten sortieren
    
    /*
    NSString *text1 = @"Rechnungen 7";
    NSString *text2 = @"Bestellungen 55";
    
    // Ein Vergleich mit der Suche nach Zahlen
    if([text1 compare: text2 options:NSNumericSearch]
       == NSOrderedAscending)
    {
        NSLog(@"%@ kommt vor %@", text1, text2);
    }
    else
    {
        NSLog(@"%@ kommt vor %@", text2, text1);
    }
     */
    
    // 3.6	Textteilbereiche mit NSRange
    
    /*
    // Der zu überprüfende Text
    NSString *errortext = @"Es ist ein Fehler aufgetreten";
    
    // Eine NSRange-Struktur
    NSRange range =
    [errortext rangeOfString:@"fehler"
                     options:NSCaseInsensitiveSearch];
    
    if(range.length > 0)
    {
        NSLog(@"Fehler!");
    } 
    else
    {
        NSLog(@"Kein Fehler");
    }
     */
    
    /*
    NSString *text = @"Hallo Cocoa Entwickler";
    NSRange range = NSMakeRange(6,5);
    
    // Die zur Verfügung stehende Länge der
    // Zeichenkette sollte überprüft werden.
    if (range.location + range.length > [text length])
    {
        NSLog(@"Achtung, dieser Bereich passt nicht!");
    }
    else
    {
        text = [text substringWithRange:range];
        NSLog(@"%@",text);
    }
     */
    
    
    // 3.7	NSMutableString
    
    /*
    // Ein NSMutableString wird deklariert
    NSMutableString *myText =
    [NSMutableString stringWithString:@"Hallo Welt"];
    
    // Ein neuer Text wird für die Variable gesetzt
    [myText setString:@"Hallo Cocoa Entwickler"];
    
    // Die Ausgabe bleibt unverändert
    NSLog(@"%@",myText);
    */
    
    /*
    // 'Hallo' durch 'Guten Morgen' ersetzten. 
    NSMutableString *myText =
    [NSMutableString stringWithString:
     @"Hallo Cocoa Entwickler"];
    
    NSRange partRange = NSMakeRange(0,5);
    [myText replaceCharactersInRange:
     partRange withString:@"Guten Morgen"];
    
    // Die erste Ausgabe
    NSLog(@"%@",myText); 
    
    // Alle 'e' duch 'A' ersetzten
    NSRange completeRange = 
    NSMakeRange(0,[myText length]);
    
    [myText replaceOccurrencesOfString:
     @"e"withString: @"A"options:
     NSCaseInsensitiveSearch range:completeRange];
    
    // Alle 'o' aus dem Text entfernen
    
    [myText replaceOccurrencesOfString:
     @"o"withString: @""options:
     NSCaseInsensitiveSearch range:completeRange];
    
    // Die zweite Ausgabe
    NSLog(@"%@",myText);
    */
        
    // 3.8	NSMutableString und Zeiger
    
    /*
    NSMutableString *textMutable1 =
    [NSMutableString stringWithString:@"Mutable Text 1"];
    
    NSMutableString *textMutable2 =
    [NSMutableString stringWithString:@"Mutable Text 2"];
    
    // Beide Objekte werden gleich gesetzt
    textMutable1 = textMutable2;
    
    [textMutable1 setString:@"Neuer Mutable Text"];
    
    NSLog(@"%@",textMutable1);
    NSLog(@"%@",textMutable2);
    */
    
    [pool drain];
    return 0;
}

